//Disable $fn and $fa, do not change these
$fn=0;
$fa=0.01;
$fs=0.5;


m3r=1.6;
m3hr=3;
m3hh=2;


backthickness=3;
backheight=60;
backdepth=50;
backshift=45;
backspace=30;

module back()
{
 difference()
 {   
  cube([backthickness,backdepth,backheight]);
    
  translate([0,backdepth/2-backspace/2,backshift]) rotate([0,90,0]) cylinder(backthickness,m3r,m3r);  
     
  translate([0,backdepth/2+backspace/2,backshift]) rotate([0,90,0]) cylinder(backthickness,m3r,m3r);       
     
 }   
}

//

// fan cube

cubew=32;
cubeh=30;
cubed=40;


v6rad=22.3/2;

fanrad=24/2+1;
fanrad2=fanrad-2;
fandepth=18;

exitwidth=cubew-13;
exitdepth=15;

cubebase=2;

fanboltdepth=3;
fanboltrad=2.5/2;
fanboltoffset=12;

module fancube()
{
difference()
{
union()
{
    
cube([cubew,cubed,cubeh]);



}

translate([cubew/2,cubed/2,0]) cylinder(cubeh,v6rad,v6rad);


translate([cubew/2,fandepth,cubeh/2]) rotate([90,0,0]) cylinder(fandepth,fanrad2,fanrad);


translate([cubew/2-fanboltoffset,fanboltdepth,cubeh/2+fanboltoffset]) rotate([90,0,0]) cylinder(fanboltdepth,fanboltrad,fanboltrad);

translate([cubew/2+fanboltoffset,fanboltdepth,cubeh/2+fanboltoffset]) rotate([90,0,0]) cylinder(fanboltdepth,fanboltrad,fanboltrad);

translate([cubew/2-fanboltoffset,fanboltdepth,cubeh/2-fanboltoffset]) rotate([90,0,0]) cylinder(fanboltdepth,fanboltrad,fanboltrad);

translate([cubew/2+fanboltoffset,fanboltdepth,cubeh/2-fanboltoffset]) rotate([90,0,0]) cylinder(fanboltdepth,fanboltrad,fanboltrad);




translate([(cubew-exitwidth)/2,(cubed-exitdepth),cubebase])cube([exitwidth,exitdepth,cubeh-cubebase]);




}
}




// v6 block


v6depth=cubed;
v6width=cubew;



v6r1=16/2;
v6r2=12/2;

v6h1=3.0;
v6h2=5.9;
v6h3=3.7;

v6height=v6h1+v6h2+v6h3;


m3r=1.6;
m3hr=3;
m3hh=2;


v6miss=2;


exholey=v6depth/2;
exholex=v6width/2;

m3nh=3;
m3nd=3;
m3nw=3;


module nut()
{
    cylinder(r = 5.5 / 2 / cos(180 / 6) + 0.2, $fn=6);
}


slotwidth=3;
slotdepth=8;
slotheight=6;
slotmargin=3;
slot2xoffset=23+20;
slot2yoffset=18+20;

bracketdepth=25;
bracketwidth=3;
bracketheight=v6height-3;
bracketdepth2=slot2xoffset-v6depth+exholey-backspace/2+7+slotdepth/2;


slot2height=16;
slot2shift=10;

bracketheight2=8;

module v6mount()
{
 // slot in front of top
 yr3=exholey-backspace/2+7;
 xr3=cubew-m3nw*2;
    
    
    
difference()
{
  union()
  {  
    cube([v6width,v6depth,v6height]);
    translate([v6width-slotwidth,yr3-slotdepth/2,v6height])cube([slotwidth,slotdepth,slotheight]);
      
    translate([v6width-bracketwidth,-bracketdepth,v6height-bracketheight]) cube([bracketwidth,bracketdepth,bracketheight]);
      
    translate([v6width-bracketwidth,v6depth,-cubeh])  cube([bracketwidth,bracketdepth2,bracketheight2]);
      
    translate([v6width-slotwidth,yr3-slotdepth/2+slot2xoffset,v6height-slot2yoffset-slot2shift])cube([slotwidth,slotdepth,slot2height]);


      
      
  }
translate([exholex,exholey,0]) cylinder(v6h1,v6r1,v6r1);    
translate([exholex,exholey,v6h1]) cylinder(v6h2,v6r2,v6r2);    
    
translate([exholex,exholey,v6h1+v6h2]) cylinder(v6h3,v6r1,v6r1);


//yr=exholey-v6r1-v6miss;
yr1=exholey-backspace/2;
    
translate([0,yr1,v6height/2])
rotate([0,90,0]) cylinder(v6width,m3r,m3r);    

translate([0,yr1,v6height/2])
rotate([0,90,0]) nut();

translate([0,yr1-m3nd,v6height/2-m3nh]) cube([m3nw,2*m3nd,v6height/2+m3nh]);


translate([v6width-m3hh,yr1,v6height/2])
rotate([0,90,0]) cylinder(m3hh,m3hr,m3hr);    


//yr=exholey+v6r1+v6miss;
yr2=exholey+backspace/2;
    
translate([0,yr2,v6height/2])
rotate([0,90,0]) cylinder(v6width,m3r,m3r);    

translate([0,yr2,v6height/2])
rotate([0,90,0]) nut();

translate([0,yr2-m3nd,v6height/2-m3nh]) cube([m3nw,2*m3nd,v6height/2+m3nh]);



translate([v6width-m3hh,yr2,v6height/2])
rotate([0,90,0])  cylinder(m3hh,m3hr,m3hr);


// slot in front of top
// yr3=exholey-backspace/2+7;
// xr3=cubew-m3nw*2;

translate([xr3,yr3,v6height/2])
rotate([0,90,0]) cylinder(v6width,m3r,m3r);    

translate([xr3,yr3,v6height/2])
rotate([0,90,0]) nut();

translate([xr3,yr3-m3nd,v6height/2-m3nh]) cube([m3nw,2*m3nd,v6height+m3nh]);

translate([xr3+m3nw,yr3-m3r,v6height/2]) cube([m3nw,2*m3r,v6height/2+slotheight-m3r-slotmargin]);

translate([xr3,yr3,v6height+slotheight-m3r-slotmargin])
rotate([0,90,0]) cylinder(v6width,m3r,m3r);    

// right hand bracket slot

translate([xr3,yr3+slot2xoffset,v6height/2-slot2yoffset])
rotate([0,90,0]) cylinder(v6width,m3r,m3r);    

translate([xr3+m3nw,yr3-m3r+slot2xoffset,v6height/2-slot2yoffset]) cube([m3nw,2*m3r,v6height/2+slotheight-m3r-slotmargin]);

translate([xr3,yr3+slot2xoffset,v6height+slotheight-m3r-slotmargin-slot2yoffset])
rotate([0,90,0]) cylinder(v6width,m3r,m3r);    

// left hand bracket holes

yr4=-bracketdepth/3;
    
translate([0,yr4,v6height-bracketheight/2])
rotate([0,90,0]) cylinder(v6width,m3r,m3r);    


yr5=-(2*bracketdepth)/3;
    
translate([0,yr5,v6height-bracketheight/2])
rotate([0,90,0]) cylinder(v6width,m3r,m3r);    


}
}






v6shift=backshift-v6height/2-cubeh;

module part()
{
translate([-backthickness,-backdepth/2,-backshift])back();

translate([0,-v6depth/2,-v6height/2-v6shift]) v6mount();

translate([0,-cubed/2,-cubeh-v6height/2-v6shift])fancube();
}









translate([-20,0,0]) intersection()
{
 part();
 translate([-backthickness,-backdepth/2,-backshift]) cube([cubew/2+backthickness,backdepth,backheight]);
}



intersection()
{
 part();
 translate([cubew/2,-cubed/2-bracketdepth,-v6shift-cubeh-v6height/2-slot2shift]) cube([cubew/2,cubed+bracketdepth+bracketdepth2,cubeh+v6height+slot2height]);
}



//part();

